Rem Program do cyfrowego rejestratora warunkw atmosferycznych:
Rem temperatury i nasonecznienia
Rem Praca dyplomowa 2003/2004
Rem Konsultant: mgr in. Zygmunt Sumara
Rem Wynonali: Siwiec Jakub, Saletnik Zygmunt
Rem Program dla mikroprocesora 90S2313

Dim Ktory_czujnik As Bit , Ktory_wyswietlacz As Byte , Licznik_pelny As Bit       ' deklaracja zmiennych
Dim Naslonecznienie As Bit , Temperatura As Bit
Dim Sekundy As Byte , Minuty As Byte , Godziny As Byte , Dni As Byte
Dim Dni_jednostki As Byte , Dni_dziesiatki As Byte
Dim Sekundy_nasl As Byte , Minuty_nasl As Byte
Dim Sekundy_temp As Byte , Minuty_temp As Byte
Dim Setki As Byte , Dziesiatki As Byte , Jednostki As Byte ,
Dim Setki_nasl As Byte , Dziesiatki_nasl As Byte , Jednostki_nasl As Byte
Dim Dziesiatki_temp As Byte , Jednostki_temp As Byte , Setki_temp As Byte
Rem Sekundy, Minuty, Godziny, Dni, Dni_jednostki, Dni_dziesiatki
Rem to zmienne dotyczce czasu jaki upyn od resetu urzdzenia
Rem Sekundy_nasl, Minuty_nasl, Setki_nasl, dziesiatki_nasl, jednostki_nasl
Rem to zmienne dotyczce czasu mierzonego nasonecznienia
Rem Sekundy_temp, Minuty_temp, Setki_temp, dziesiatki_temp, jednostki_temp
Rem to zmienne dotyczce czasu mierzonej temperatury
Rem Setki, Dziesiatki, Jednostki
Rem to zmienne dotyczce wywietlanego aktualnie wyniku
Rem ktory_wyswietlacz - decyduje o tym, ktry wywietlacz
Rem wieci si w danej chwili
Rem Naslonecznienie, Temperatura - od ich wartoci zaley czy mikroprocesor
Rem bdzie zlicza czas (jeeli 1 to zlicza)
Rem Ktory_czujnik - warto tej zmiennej zaley od pooenia przecznika,
Rem informuje ona mikroprocesor ktry wynik ma by wywietlany

Config Portb = &B00101111       'Konfiguracja portu B
Rem 0 to wejcie, a 1 to wyjcie
Portb = &B00000000       'Stany wej/wyj portu B
Config Portd = &B0011111 'Konfiguracja portu D
Portd = &B1100000        'Stany wej/wyj portu D

Config Timer0 = Timer , Prescale = 64       'Konfiguracja Timer0 (licznika nr 0)
Config Timer1 = Timer , Prescale = 64       'Konfiguracja Timer1 (licznika nr 1)
Enable Interrupts        'Odblokowanie przerwa
Enable Timer0            'Odblokowanie przerwa pochodzcych od Timer0
Enable Timer1            'Odblokowanie przerwa pochodzcych od Timer1
On Timer0 Co4ms          'Po przepenieniu licznika Timer0 skocz do etykiety o nazwie Co4ms
On Timer1 Co1s Nosave    'Po przepenieniu licznika Timer1 skocz do etykiety o nazwie Co1s

Sekundy = 0              'Pocztkowe stany zmiennych
Minuty = 0
Godziny = 0
Dni = 23                 'Dla przykadu
Dni_jednostki = 0
dni_dziesiatki = 0
Sekundy_nasl = 50        'Dla przykadu
sekundy_temp = 0
Minuty_nasl = 59         'Dla przykadu
Minuty_temp = 0
licznik_pelny = 0
Setki = 0
Dziesiatki = 0
Jednostki = 0
Setki_nasl = 9           'Dla przykadu
Setki_temp = 2           'Dla przykadu
Dziesiatki_nasl = 9      'Dla przykadu
Dziesiatki_temp = 2      'Dla przykadu
Jednostki_nasl = 8       'Dla przykadu
Jednostki_temp = 2       'Dla przykadu
Stop Ac                  'Wycz komparator mikroprocesora (zmniejszenie poboru prdu)
Do
Rem Program gwny
Loop
End
Co1s:                    'Procedura realizowana co 1 sekund
Load Timer1 , 62500      'Aby przerwanie byo realizowane dokdnie co 1 sekund

If Licznik_pelny = 0 Then       'Jeeli licznik osignie stan maksymalny to zablokuj zliczanie
Incr Sekundy             'Zwiksz o 1 warto zmiennej Sekundy
If Naslonecznienie = 1 Then Incr sekundy_nasl
If Temperatura = 1 Then Incr Sekundy_temp       'Jezeli odpowiednia temperatura to zliaczaj czas
End If
Return                   'Koniec przerwania realizowanegoco 1s

Co4ms:                   'Przerwanie realizowane co 4,096 ms
Portb.5 = licznik_pelny  'Gdy mikroprocesor nie zlicza to sygnalizuj (ta dioda)
Naslonecznienie = Pinb.4 'Zmiennej Naslonecznienie przypisz sygna wejciowy z wejcia Portb.4
Temperatura = Pinb.6
If Pind.6 = 0 Then       'Jeeli umieszczony klucz zerujcy w gniedzie
Sekundy_nasl = 0         'to wyzeruj zmienne
sekundy_temp = 0
minuty_nasl = 0
minuty_temp = 0
Setki_nasl = 0
setki_temp = 0
dziesiatki_nasl = 0
jednostki_nasl = 0
Dziesiatki_temp = 0
jednostki_temp = 0
Sekundy = 0
Minuty = 0
Godziny = 0
Dni = 0
licznik_pelny = 0
End If

If Sekundy_nasl = 60 Then       'Skrcenie cyklu zliczania sekund 0d 0 do 59
sekundy_nasl = 0
Incr minuty_nasl
End If

If minuty_nasl = 60 Then
minuty_nasl = 0
Incr jednostki_nasl
End If

If jednostki_nasl = 10 Then
jednostki_nasl = 0
Incr Dziesiatki_nasl
End If

If dziesiatki_nasl = 10 Then
dziesiatki_nasl = 0
Incr Setki_nasl
End If
If setki_nasl > 9 Then setki_nasl = 9

If sekundy_temp = 60 Then
sekundy_temp = 0
Incr minuty_temp
End If

If minuty_temp = 60 Then
minuty_temp = 0
Incr jednostki_temp
End If

If jednostki_temp = 10 Then
jednostki_temp = 0
Incr Dziesiatki_temp
End If

If dziesiatki_temp = 10 Then
Dziesiatki_temp = 0
Incr setki_temp
End If
If setki_temp > 9 Then setki_temp = 9

Ktory_czujnik = Pinb.7   'Zmiennej Ktory_czujnik przypisz sygna z wejcia Portb.7
If Ktory_czujnik = 0 Then       'Jeeli 0 to wywietlaj czas nasonecznienia
Setki = Setki_nasl
Dziesiatki = Dziesiatki_nasl
Jednostki = Jednostki_nasl
End If
If Ktory_czujnik = 1 Then       'Jeli 1 to wywietlaj czas temperatury
Setki = Setki_temp
Dziesiatki = Dziesiatki_temp
Jednostki = Jednostki_temp
End If

If setki_nasl = 9 And dziesiatki_nasl = 9 And jednostki_nasl = 9 Then licznik_pelny = 1
If setki_temp = 9 And dziesiatki_temp = 9 And jednostki_temp = 9 Then licznik_pelny = 1
Rem Jeeli wskazanie na dolnym wywietlaczu 999 to zablokuj zliczanie
If Sekundy = 60 Then
   Sekundy = 0
   Incr Minuty
End If
If Minuty = 60 Then
   Minuty = 0
   Incr Godziny
End If
If Godziny = 24 Then
Godziny = 0
Incr Dni                 'Ta zmienna jest wywietlana na grnym wywietlaczu
End If
If Dni > 99 Then Dni = 99
If Dni = 99 Then Licznik_pelny = 1       'Jeeli stan grnego wywietlacza 99 to zablokuj zliczanie

Dni_dziesiatki = Makebcd(dni)       'Zamieniamy liczb dwjkow na BCD
Dni_jednostki = Dni_dziesiatki And 15       'Uzyskujemy tylko cztery modsze bity - jednostki dni
Shift Dni_dziesiatki , Right , 4       'Przesuwamy w prawo i usuwany 4 modsze bity - dziesitki dni

Portd = &B00000
Portb = &B0000
Incr ktory_wyswietlacz
If ktory_wyswietlacz = 5 Then ktory_wyswietlacz = 0
Select Case Ktory_wyswietlacz       'Obsuga wywietlaczy
Case 0:                  'Wywietl zawarto licznika jednostek dni
Portd = &B00000
Portb = &B0000
   Portb = Lookup(dni_jednostki , Tabela)
   Portd = &B00001
Case 1:                  'Wywietl zawarto licznika dziesitek dni
Portd = &B00000
Portb = &B0000
   Portb = Lookup(dni_dziesiatki , Tabela)
   Portd = &B00010
Case 2:                  'Wywietl zawarto licznika jednostek godzin
Portd = &B00000
Portb = &B0000
   Portb = Lookup(jednostki , Tabela)
   Portd = &B00100
Case 3:                  'Wywietl zawarto licznika dziesitek godzin
Portd = &B00000
Portb = &B0000
   Portb = Lookup(dziesiatki , Tabela)
   Portd = &B01000
Case 4:                  'Wywietl zawarto licznika setek godzin
Portd = &B00000
Portb = &B0000
   Portb = Lookup(setki , Tabela)
   Portd = &B10000

End Select
Return                   'Koniec obsugi przerwania od T/C0 co 4,096ms

Tabela:
Rem Kody BCD wysyane do sterownika wywietlaczy (4511)
Data &B0000 , &B0001 , &B0010 , &B0011 , &B0100 , &B0101 , &B0110 , &B0111 , &B1000 , &B1001